import { Decoration, NodeView as ProseMirrorNodeView } from 'prosemirror-view';
import { Node as ProseMirrorNode } from 'prosemirror-model';
import { Editor as CoreEditor } from './Editor';
import { Node } from './Node';
import { NodeViewRendererProps, NodeViewRendererOptions } from './types';
export declare class NodeView<Component, Editor extends CoreEditor = CoreEditor> implements ProseMirrorNodeView {
    component: Component;
    editor: Editor;
    extension: Node;
    node: ProseMirrorNode;
    decorations: Decoration[];
    getPos: any;
    isDragging: boolean;
    options: NodeViewRendererOptions;
    constructor(component: Component, props: NodeViewRendererProps, options?: Partial<NodeViewRendererOptions>);
    mount(): void;
    get dom(): Element | null;
    get contentDOM(): Element | null;
    onDragStart(event: DragEvent): void;
    stopEvent(event: Event): boolean;
    ignoreMutation(mutation: MutationRecord | {
        type: 'selection';
        target: Element;
    }): boolean;
    updateAttributes(attributes: {}): void;
    deleteNode(): void;
}
